package task9;

import java.util.Map;
import java.util.Set;

/**
 * 1. Создать класс Mathbox. В классе в коллекции хранятся данные - целые числа. Числа не могут повторяться.
 * а. В классе есть методы, добавляющие и удаляющие объекты в/из коллекции.
 * б. В классе есть метод getTotal(), возвращающий сумму всех объектов
 * в. В классе есть метод getAverage(), возвращающий среднее значение вхождений
 * г. В классе есть метод getMultiplied(int multiplicator), возвращающий новую коллекцию, в которой все элементы
 * умножены на множитель. Коллекция в объекте при этом изменяется.
 * д. В классе есть метод getMap(), возвращающее Map<Integer, String>, в которой ключи и значения
 * это одни и те же элементы, приведенные к разным типам.
 * е. Метод getMax(), возвращающий максимальное число
 * ж. Метод getMin(), возвращающий минимальное число
 * з. Создать аннотацию ClearData. Создать прокси-объект, который при наличии у метода этой аннотации после
 * выполнения метода очистит коллекцию в объекте.
 * е. Создать аннотацию LogData. При наличии у метода исходного объекта этой аннотации необходимо сделать так,
 * чтобы до и после выполнения метода в консоль выводилась коллекция объекта.
 */
public interface MathBoxable {

    /**
     * @return сумма всех объектов (если элементов нет возвращает 0)
     */
    public int getTotal();

    /**
     * @return среднее округленное значение вхождений (если элементов нет возвращает 0)
     */
    public int getAverage();

    /**
     * возвращает новую коллекцию, в которой все элементы
     * умножены на множитель. Коллекция в объекте при этом изменяется.
     *
     * @param multiplicator множитель
     * @return новая коллекция
     */
    public Set<Integer> getMultiplied(int multiplicator);

    /**
     * возвращает коллекцию в которой ключи и значения
     * это одни и те же элементы, приведенные к разным типам.
     *
     * @return новая Map коллекция
     */
    public Map<Integer, String> getMap();

    /**
     * @return максимальное число
     */
    public int getMax();

    /**
     * @return минимальное число
     */
    public int getMin();

    /**
     * удаляет элемент из коллекции
     *
     * @param i элемент
     * @return если элемента в коллекции нет, то возвращает false
     */
    @ClearData
    @LogData
    public boolean remove(int i);

    /**
     * добавляет элемент в коллекцию
     *
     * @param i элемент
     * @return если элемент уже есть в коллекции, то возвращает false
     */
    @LogData
    public boolean add(int i);


}
